diff -crN nakedmudv1.5/src/cmd_manip.c nakedmudv2.0/src/cmd_manip.c
*** nakedmudv1.5/src/cmd_manip.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/cmd_manip.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 13,19 ****
  #include "handler.h"
  #include "inform.h"
  #include "character.h"
- #include "items.h"
  #include "exit.h"
  #include "world.h"
  #include "room.h"
--- 13,18 ----
***************
*** 22,27 ****
--- 21,34 ----
  
  
  
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "items/items.h"
+ #include "items/container.h"
+ 
+ 
+ 
  //
  // try to lock an exit or container. The container can be anything in our
  // immediate visible range (room, inventory, body). do_lock automatically
***************
*** 67,73 ****
    }
  
    else if(found && found_type == FOUND_OBJ) {
!     if(objGetType(found) != ITEM_CONTAINER)
        send_to_char(ch, "%s is not a container.\r\n", objGetName(found));
      else if(!containerIsClosed(found))
        send_to_char(ch, "%s must be closed first.\r\n", objGetName(found));
--- 74,80 ----
    }
  
    else if(found && found_type == FOUND_OBJ) {
!     if(!objIsType(found, "container"))
        send_to_char(ch, "%s is not a container.\r\n", objGetName(found));
      else if(!containerIsClosed(found))
        send_to_char(ch, "%s must be closed first.\r\n", objGetName(found));
***************
*** 125,131 ****
    }
  
    else if(found && found_type == FOUND_OBJ) {
!     if(objGetType(found) != ITEM_CONTAINER)
        send_to_char(ch, "%s is not a container.\r\n", objGetName(found));
      else if(!containerIsLocked(found))
        send_to_char(ch, "%s is not locked.\r\n", objGetName(found));
--- 132,138 ----
    }
  
    else if(found && found_type == FOUND_OBJ) {
!     if(!objIsType(found, "container"))
        send_to_char(ch, "%s is not a container.\r\n", objGetName(found));
      else if(!containerIsLocked(found))
        send_to_char(ch, "%s is not locked.\r\n", objGetName(found));
***************
*** 186,192 ****
    }
  
    // make sure we have a container
!   if(objGetType(cont) != ITEM_CONTAINER) {
      send_to_char(ch, "%s is not a container.\r\n", objGetName(cont));
      return;
    }
--- 193,199 ----
    }
  
    // make sure we have a container
!   if(!objIsType(cont, "container")) {
      send_to_char(ch, "%s is not a container.\r\n", objGetName(cont));
      return;
    }
***************
*** 253,259 ****
    // open a container
    else if(found && found_type == FOUND_OBJ) {
      // make sure it's a container and it can be opened
!     if(objGetType(found) != ITEM_CONTAINER || !containerIsClosable(found))
        send_to_char(ch, "But it cannot be opened!\r\n");
      else if(!containerIsClosed(found))
        send_to_char(ch, "It is already opened.\r\n");
--- 260,266 ----
    // open a container
    else if(found && found_type == FOUND_OBJ) {
      // make sure it's a container and it can be opened
!     if(!objIsType(found, "container") || !containerIsClosable(found))
        send_to_char(ch, "But it cannot be opened!\r\n");
      else if(!containerIsClosed(found))
        send_to_char(ch, "It is already opened.\r\n");
***************
*** 315,321 ****
    // close a container
    else if(found && found_type == FOUND_OBJ) {
      // make sure it's a container and it can be closed
!     if(objGetType(found) != ITEM_CONTAINER || !containerIsClosable(found))
        send_to_char(ch, "But it cannot even be closed!\r\n");
      else if(containerIsClosed(found))
        send_to_char(ch, "It is already closed.\r\n");
--- 322,328 ----
    // close a container
    else if(found && found_type == FOUND_OBJ) {
      // make sure it's a container and it can be closed
!     if(!objIsType(found, "container") || !containerIsClosable(found))
        send_to_char(ch, "But it cannot even be closed!\r\n");
      else if(containerIsClosed(found))
        send_to_char(ch, "It is already closed.\r\n");
***************
*** 361,367 ****
        send_to_char(ch, "Get what from what?\r\n");
        return;
      }
!     else if(objGetType(cont) != ITEM_CONTAINER) {
        send_to_char(ch, "%s is not a container.\r\n", objGetName(cont));
        return;
      }
--- 368,374 ----
        send_to_char(ch, "Get what from what?\r\n");
        return;
      }
!     else if(!objIsType(cont, "container")) {
        send_to_char(ch, "%s is not a container.\r\n", objGetName(cont));
        return;
      }
diff -crN nakedmudv1.5/src/cmd_manip.d nakedmudv2.0/src/cmd_manip.d
*** nakedmudv1.5/src/cmd_manip.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/cmd_manip.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ cmd_manip.d cmd_manip.o: cmd_manip.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h handler.h inform.h \
+   character.h exit.h world.h room.h extra_descs.h object.h items/items.h \
+   items/container.h
diff -crN nakedmudv1.5/src/cmd_misc.c nakedmudv2.0/src/cmd_misc.c
*** nakedmudv1.5/src/cmd_misc.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/cmd_misc.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 34,62 ****
  
  
  //
- // Various preference bits that can be turned on and off
- //
- COMMAND(cmd_tog_prf) {
-   switch(subcmd) {
-   case PRF_MAPWALK:
-     charToggleBit(ch, BITFIELD_PRFS, PRF_MAPWALK);
-     send_to_char(ch, "Mapwalk %s.\r\n",
- 		 (charIsBitSet(ch, BITFIELD_PRFS, PRF_MAPWALK) ? "on":"off"));
-     break;
-   case PRF_BUILDWALK:
-     charToggleBit(ch, BITFIELD_PRFS, PRF_BUILDWALK);
-     send_to_char(ch, "Buildwalk %s.\r\n", 
- 		 (charIsBitSet(ch, BITFIELD_PRFS, PRF_BUILDWALK) ? "on":"off"));
-     break;
- 
-   default:
-     log_string("ERROR: attempted to toggle prf with subcmd %d on %s, but "
- 	       "subcmd does not exit!", subcmd, charGetName(ch));
-   }
- }
- 
- 
- //
  // clear the screen
  //
  COMMAND(cmd_clear) {
--- 34,39 ----
***************
*** 83,90 ****
    //
    if(charGetSocket(ch)) {
      SOCKET_DATA *sock = charGetSocket(ch);
-     sock->player = NULL;
      charSetSocket(ch, NULL);
      close_socket(sock, FALSE);
    }
  
--- 60,67 ----
    //
    if(charGetSocket(ch)) {
      SOCKET_DATA *sock = charGetSocket(ch);
      charSetSocket(ch, NULL);
+     socketSetChar(sock, NULL);
      close_socket(sock, FALSE);
    }
  
***************
*** 103,136 ****
  
  
  //
- // compress output
- //
- COMMAND(cmd_compress)
- {
-   /* no socket, no compression */
-   if (!charGetSocket(ch))
-     return;
- 
-   /* enable compression */
-   if (!charGetSocket(ch)->out_compress)
-   {
-     text_to_char(ch, "Trying compression.\n\r");
-     text_to_buffer(charGetSocket(ch), (char *) compress_will2);
-     text_to_buffer(charGetSocket(ch), (char *) compress_will);
-   }
-   else /* disable compression */
-   {
-     if (!compressEnd(charGetSocket(ch), charGetSocket(ch)->compressing, FALSE))
-     {
-       text_to_char(ch, "Failed.\n\r");
-       return;
-     }
-     text_to_char(ch, "Compression disabled.\n\r");
-   }
- }
- 
- 
- //
  // the function for executing a delayed command
  //
  void event_delayed_cmd(CHAR_DATA *ch, void *data, char *cmd) {
--- 80,85 ----
***************
*** 169,177 ****
  //
  // An entrypoint into the character's notepad
  //
  COMMAND(cmd_write) {
    if(!charGetSocket(ch))
      send_to_char(ch, "You cannot use notepad if you have no socket.\r\n");
!   else
!     start_notepad(charGetSocket(ch), "", MAX_BUFFER, EDITOR_MODE_NORMAL);
  }
--- 118,131 ----
  //
  // An entrypoint into the character's notepad
  //
+ /*
  COMMAND(cmd_write) {
    if(!charGetSocket(ch))
      send_to_char(ch, "You cannot use notepad if you have no socket.\r\n");
!   else {
!     send_around_char(ch, TRUE, "%s pulls out a notepad and begins writing.", 
! 		     charGetName(ch));
!     start_notepad(charGetSocket(ch), "");
!   }
  }
+ */
diff -crN nakedmudv1.5/src/cmd_misc.d nakedmudv2.0/src/cmd_misc.d
*** nakedmudv1.5/src/cmd_misc.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/cmd_misc.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ cmd_misc.d cmd_misc.o: cmd_misc.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h character.h socket.h utils.h \
+   save.h event.h action.h handler.h
diff -crN nakedmudv1.5/src/commands.h nakedmudv2.0/src/commands.h
*** nakedmudv1.5/src/commands.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/commands.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 17,22 ****
--- 17,24 ----
  COMMAND(cmd_wizhelp);
  COMMAND(cmd_invis);
  COMMAND(cmd_visible);
+ COMMAND(cmd_repeat);
+ COMMAND(cmd_at);
  
  
  /* builder.c */
***************
*** 31,36 ****
--- 33,39 ----
  COMMAND(cmd_olist);
  COMMAND(cmd_dlist);
  COMMAND(cmd_zlist);
+ COMMAND(cmd_buildwalk);
  
  
  /* cmd_manip.c */
***************
*** 54,59 ****
--- 57,63 ----
  COMMAND(cmd_chat);
  COMMAND(cmd_emote);
  COMMAND(cmd_gemote);
+ COMMAND(cmd_page);
  
  
  /* cmd_misc.c */
***************
*** 63,73 ****
  COMMAND(cmd_save);
  COMMAND(cmd_commands);
  COMMAND(cmd_compress);
- COMMAND(cmd_tog_prf);
  COMMAND(cmd_more);
  COMMAND(cmd_back);
  COMMAND(cmd_stop);
- COMMAND(cmd_write);
  
  
  /* inform.c */
--- 67,75 ----
diff -crN nakedmudv1.5/src/depend.sh nakedmudv2.0/src/depend.sh
*** nakedmudv1.5/src/depend.sh	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/depend.sh	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,11 ----
+ #!/bin/sh
+ 
+ DIR=$(dirname $1)
+ case "$DIR" in
+ "" | ".")
+ gcc -MM -MG "$@" | sed -e 's@^\(.*\)\.o:@\1.d \1.o:@'
+ ;;
+ *)
+ gcc -MM -MG "$@" | sed -e "s@^\(.*\)\.o:@$DIR/\1.d $DIR/\1.o:@" 
+ ;;
+ esac
diff -crN nakedmudv1.5/src/dialog.c nakedmudv2.0/src/dialog.c
*** nakedmudv1.5/src/dialog.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/dialog.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 17,30 ****
  struct dialog_data {
    int   vnum;      // what vnum are we in the world?
    char *name;      // the name of this dialog (e.g. generic citizen dialog)
!   char *greet;     // what do we say when someone approaches/greets us?
    LIST *responses; // what kind of topics do we talk about?
  };
  
  
  struct response_data {
    char *keywords;      // what triggers the talking?
!   char *message;       // what is the response?
    DIALOG_DATA *dialog; // which dialog do we belong to?
  };
  
--- 17,30 ----
  struct dialog_data {
    int   vnum;      // what vnum are we in the world?
    char *name;      // the name of this dialog (e.g. generic citizen dialog)
!   BUFFER *greet;   // what do we say when someone approaches/greets us?
    LIST *responses; // what kind of topics do we talk about?
  };
  
  
  struct response_data {
    char *keywords;      // what triggers the talking?
!   BUFFER *message;     // what is the response?
    DIALOG_DATA *dialog; // which dialog do we belong to?
  };
  
***************
*** 33,62 ****
  //*****************************************************************************
  //
  // response stuff
! //
  //*****************************************************************************
! RESPONSE_DATA *newResponse(const char *keywords, const char *message) {
    RESPONSE_DATA *response = malloc(sizeof(RESPONSE_DATA));
!   response->keywords = strdup(keywords ? keywords : "");
!   response->message  = strdup(message  ? message  : "");
    response->dialog = NULL;
    return response;
  }
  
  void deleteResponse(RESPONSE_DATA *response) {
    if(response->keywords) free(response->keywords);
!   if(response->message)  free(response->message);
    free(response);
  }
  
  RESPONSE_DATA *responseRead(STORAGE_SET *set) {
!   return newResponse(read_string(set, "keywords"), read_string(set, "message"));
  }
  
  STORAGE_SET *responseStore(RESPONSE_DATA *data) {
    STORAGE_SET *set = new_storage_set();
    store_string(set, "keywords", data->keywords);
!   store_string(set, "message",  data->message);
    return set;
  }
  
--- 33,65 ----
  //*****************************************************************************
  //
  // response stuff
! 
  //*****************************************************************************
! RESPONSE_DATA *newResponse(void) {
    RESPONSE_DATA *response = malloc(sizeof(RESPONSE_DATA));
!   response->keywords = strdup("");
!   response->message  = newBuffer(1);
    response->dialog = NULL;
    return response;
  }
  
  void deleteResponse(RESPONSE_DATA *response) {
    if(response->keywords) free(response->keywords);
!   if(response->message)  deleteBuffer(response->message);
    free(response);
  }
  
  RESPONSE_DATA *responseRead(STORAGE_SET *set) {
!   RESPONSE_DATA *response = newResponse();
!   responseSetKeywords(response, read_string(set, "keywords"));
!   responseSetMessage (response, read_string(set, "message"));
!   return response;
  }
  
  STORAGE_SET *responseStore(RESPONSE_DATA *data) {
    STORAGE_SET *set = new_storage_set();
    store_string(set, "keywords", data->keywords);
!   store_string(set, "message",  bufferString(data->message));
    return set;
  }
  
***************
*** 66,72 ****
  }
  
  RESPONSE_DATA *responseCopy(RESPONSE_DATA *response) {
!   RESPONSE_DATA *newresp = newResponse(response->keywords, response->message);
    return newresp;
  }
  
--- 69,76 ----
  }
  
  RESPONSE_DATA *responseCopy(RESPONSE_DATA *response) {
!   RESPONSE_DATA *newresp = newResponse();
!   responseCopyTo(response, newresp);
    return newresp;
  }
  
***************
*** 88,95 ****
  }
  
  void responseSetMessage(RESPONSE_DATA *response, const char *message) {
!   if(response->message) free(response->message);
!   response->message = strdup(message ? message : "");
  }
  
  const char *responseGetKeywords(RESPONSE_DATA *response) {
--- 92,99 ----
  }
  
  void responseSetMessage(RESPONSE_DATA *response, const char *message) {
!   bufferClear(response->message);
!   bufferCat(response->message, message);
  }
  
  const char *responseGetKeywords(RESPONSE_DATA *response) {
***************
*** 97,105 ****
  }
  
  const char *responseGetMessage(RESPONSE_DATA *response) {
!   return response->message;
  }
  
  
  
  
--- 101,112 ----
  }
  
  const char *responseGetMessage(RESPONSE_DATA *response) {
!   return bufferString(response->message);
  }
  
+ BUFFER *responseGetMessageBuffer(RESPONSE_DATA *response) {
+   return response->message;
+ }
  
  
  
***************
*** 111,118 ****
  DIALOG_DATA *newDialog() {
    DIALOG_DATA *dialog = malloc(sizeof(DIALOG_DATA));
    dialog->responses = newList();
    dialog->name  = strdup("");
-   dialog->greet = strdup("");
    dialog->vnum  = NOTHING;
    return dialog;
  }
--- 118,125 ----
  DIALOG_DATA *newDialog() {
    DIALOG_DATA *dialog = malloc(sizeof(DIALOG_DATA));
    dialog->responses = newList();
+   dialog->greet = newBuffer(1);
    dialog->name  = strdup("");
    dialog->vnum  = NOTHING;
    return dialog;
  }
***************
*** 121,128 ****
    RESPONSE_DATA *response = NULL;
    while( (response = listPop(dialog->responses)) != NULL)
      deleteResponse(response);
    if(dialog->name)  free(dialog->name);
-   if(dialog->greet) free(dialog->greet);
    free(dialog);
  }
  
--- 128,135 ----
    RESPONSE_DATA *response = NULL;
    while( (response = listPop(dialog->responses)) != NULL)
      deleteResponse(response);
+   if(dialog->greet) deleteBuffer(dialog->greet);
    if(dialog->name)  free(dialog->name);
    free(dialog);
  }
  
***************
*** 130,136 ****
    STORAGE_SET *set = new_storage_set();
    store_int   (set, "vnum",     dialog->vnum);
    store_string(set, "name",     dialog->name);
!   store_string(set, "greet",    dialog->greet);
    store_list(set, "responses", gen_store_list(dialog->responses,responseStore));
    return set;
  }
--- 137,143 ----
    STORAGE_SET *set = new_storage_set();
    store_int   (set, "vnum",     dialog->vnum);
    store_string(set, "name",     dialog->name);
!   store_string(set, "greet",    bufferString(dialog->greet));
    store_list(set, "responses", gen_store_list(dialog->responses,responseStore));
    return set;
  }
***************
*** 167,177 ****
    deleteListIterator(resp_i);
  
    // now the name and greet
    if(to->name) free(to->name);
-   if(to->greet) free(to->greet);
- 
    to->name  = strdup(from->name ? from->name : "");
-   to->greet = strdup(from->greet ? from->greet : "");
    to->vnum  = from->vnum;
  }
  
--- 174,183 ----
    deleteListIterator(resp_i);
  
    // now the name and greet
+   bufferClear(to->greet);
+   bufferCat(to->greet, bufferString(from->greet));
    if(to->name) free(to->name);
    to->name  = strdup(from->name ? from->name : "");
    to->vnum  = from->vnum;
  }
  
***************
*** 217,223 ****
    ITERATE_LIST(response, resp_i)
      if(responseIsKeyword(response, keyword))
        break;
-   
    deleteListIterator(resp_i);
    return response;
  }
--- 223,228 ----
***************
*** 238,250 ****
    return listSize(dialog->responses);
  }
  
! const char *dialogGetGreet(DIALOG_DATA *dialog) {
    return dialog->greet;
  }
  
  void dialogSetGreet(DIALOG_DATA *dialog, const char *greet) {
!   if(dialog->greet) free(dialog->greet);
!   dialog->greet = strdup(greet ? greet : "");
  }
  
  void dialogSetVnum(DIALOG_DATA *dialog, dialog_vnum vnum) {
--- 243,259 ----
    return listSize(dialog->responses);
  }
  
! BUFFER *dialogGetGreetBuffer(DIALOG_DATA *dialog) {
    return dialog->greet;
  }
  
+ const char *dialogGetGreet(DIALOG_DATA *dialog) {
+   return bufferString(dialog->greet);
+ }
+ 
  void dialogSetGreet(DIALOG_DATA *dialog, const char *greet) {
!   bufferClear(dialog->greet);
!   bufferCat(dialog->greet, (greet ? greet : ""));
  }
  
  void dialogSetVnum(DIALOG_DATA *dialog, dialog_vnum vnum) {
diff -crN nakedmudv1.5/src/dialog.d nakedmudv2.0/src/dialog.d
*** nakedmudv1.5/src/dialog.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/dialog.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ dialog.d dialog.o: dialog.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h dialog.h storage.h
diff -crN nakedmudv1.5/src/editor/editor.c nakedmudv2.0/src/editor/editor.c
*** nakedmudv1.5/src/editor/editor.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/editor/editor.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,392 ----
+ //*****************************************************************************
+ //
+ // editor.c
+ //
+ // one of the problems that came up with the origional text editor what that
+ // it started becoming rather kludgy and hackish as we started adding more
+ // features to it, like script editing capabilities. It was difficult to
+ // coordinate when we wanted certain options and when we didn't. This is an
+ // attempt to make things a bit easier to scale up with.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../auxiliary.h"
+ #include "../socket.h"
+ #include "editor.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // auxiliary data for sockets
+ //*****************************************************************************
+ typedef struct editor_aux_data {
+   EDITOR *editor;      // the editor we're using
+   BUFFER *buf;         // the buffer we're editing
+   BUFFER *working_buf; // the buffer where we do our work
+ } EDITOR_AUX_DATA;
+ 
+ EDITOR_AUX_DATA *newEditorAuxData() {
+   EDITOR_AUX_DATA *data = malloc(sizeof(EDITOR_AUX_DATA));
+   bzero(data, sizeof(EDITOR_AUX_DATA));
+   return data; // the buffer, working buffer, and editor are null 'til needed
+ }
+ 
+ void deleteEditorAuxData(EDITOR_AUX_DATA *data) {
+   // if we have a working buf, free it. Don't touch anything else. that
+   // stuff will be needed by the rest of the program
+   if(data->working_buf) deleteBuffer(data->working_buf);
+   free(data);
+ }
+ 
+ void clearEditorAuxData(EDITOR_AUX_DATA *data) {
+   if(data->working_buf) deleteBuffer(data->working_buf);
+   data->working_buf = NULL;
+   data->editor      = NULL;
+   data->buf         = NULL;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // local structures, functions, and defines
+ //*****************************************************************************
+ // a basic text editor for use by other modules
+ EDITOR *text_editor = NULL;
+ // an editor for dialog. Essentially, text without newlines
+ EDITOR *dialog_editor = NULL;
+ 
+ // how many buckets are in our command table?
+ #define EDITOR_CMD_TABLE_SIZE       20
+ 
+ struct editor_data {
+   HASHTABLE *cmds;  // mappings from commands to their functions and descs
+   void (* prompt)(SOCKET_DATA *sock); // the prompt display
+   void (*   init)(SOCKET_DATA *sock); // reset variables for using the editor
+   void (* append)(SOCKET_DATA *sock, char *arg, BUFFER *buf); // append text to the buffer
+ };
+ 
+ // data for a command in the editor
+ typedef struct command_data {
+   // the function this command calls
+   void (* func)(SOCKET_DATA *sock, char *arg, BUFFER *buf);
+   char *desc;    // the one-line helpfile description
+   bool reserved; // is this command protected from being written over?
+ } CMD_DATA;
+ 
+ CMD_DATA *
+ newEditorCommand(const char *desc, 
+ 		 void func(SOCKET_DATA *sock, char *arg, BUFFER *buf),
+ 		 bool reserved) {
+   CMD_DATA *cmd = malloc(sizeof(CMD_DATA));
+   cmd->desc     = strdup(desc ? desc : "");
+   cmd->func     = func;
+   cmd->reserved = reserved;
+   return cmd;
+ }
+ 
+ void deleteEditorCommand(CMD_DATA *cmd) {
+   if(cmd->desc) free(cmd->desc);
+   free(cmd);
+ }
+ 
+ 
+ //
+ // the default prompt display for editors
+ //
+ void editorDefaultPrompt(SOCKET_DATA *sock) {
+   text_to_buffer(sock, "] ");
+ }
+ 
+ 
+ //
+ // the default header display for editors
+ //
+ void editorDefaultHeader(SOCKET_DATA *sock) {
+   text_to_buffer(sock, 
+ "==========================================================================\r\n"
+ "Begin editing. /q on a new line to quit, /a to abort. /h for help         \r\n"
+ "==========================================================================\r\n"
+ 		 );
+ }
+ 
+ 
+ //
+ // the default function for appending text to the working buffer
+ //
+ void editorDefaultAppend(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   bufferCat(buf, arg);
+   bufferCat(buf, "\r\n");
+ }
+ 
+ 
+ //
+ // the function for appending text to a dialog buffer. 
+ //
+ void editorDialogAppend(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   // if the buffer isn't empty, cat a space
+   if(bufferLength(buf) > 0)
+     bufferCat(buf, " ");
+   bufferCat(buf, arg);
+ }
+ 
+ 
+ //
+ // The function that takes in a new command and figures out what to
+ // do with it
+ //
+ void editorInputHandler(SOCKET_DATA *sock, char *arg) {
+   EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data");
+ 
+   // is it a command?
+   if(*arg == '/') {
+     // separate the command and the argument
+     char buf[SMALL_BUFFER];
+     arg = one_arg(arg, buf);
+ 
+     // pull up the command
+     CMD_DATA *cmd = hashGet(data->editor->cmds, buf+1);
+     if(cmd == NULL)
+       text_to_buffer(sock, "Invalid command.\r\n");
+     else
+       cmd->func(sock, arg, data->working_buf);
+   }
+   else
+     data->editor->append(sock, arg, data->working_buf);
+ }
+ 
+ 
+ //*****************************************************************************
+ // implementation of basic editor commands
+ //*****************************************************************************
+ void editorQuit(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   // save the current changes
+   EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data");
+   bufferCopyTo(buf, data->buf);
+   clearEditorAuxData(data);
+   text_to_buffer(sock, "Saved and quit.\r\n");
+   // and then pop the input handler
+   socketPopInputHandler(sock);
+ }
+ 
+ void editorAbort(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data");
+   clearEditorAuxData(data);
+   text_to_buffer(sock, "Editor aborted.\r\n");
+   socketPopInputHandler(sock);
+ }
+ 
+ void editorDisplayHelp(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   const char *key = NULL;
+   CMD_DATA   *val = NULL;
+   HASH_ITERATOR *hash_i = newHashIterator(socketGetEditor(sock)->cmds);
+ 
+   // print out all of the commands and their descriptions
+   ITERATE_HASH(key, val, hash_i)
+     send_to_socket(sock, "/%-3s %s\r\n", key, val->desc);
+   deleteHashIterator(hash_i);
+ }
+ 
+ void editorDeleteLine(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   char tmp[SMALL_BUFFER];
+   arg = one_arg(arg, tmp);
+   int line = atoi(tmp);
+   if(!isdigit(*tmp) || !bufferRemove(buf, line))
+     text_to_buffer(sock, "Line does not exist.\r\n");
+ }
+ 
+ void editorEditLine(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   char tmp[SMALL_BUFFER];
+   arg = one_arg(arg, tmp);
+   int line = atoi(tmp);
+   if(!isdigit(*tmp) || !bufferReplaceLine(buf, arg, line))
+     text_to_buffer(sock, "Line does not exist.\r\n");
+ }
+ 
+ void editorInsertLine(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   char tmp[SMALL_BUFFER];
+   arg = one_arg(arg, tmp);
+   int line = atoi(tmp);
+   if(!isdigit(*tmp) || !bufferInsert(buf, arg, line))
+     text_to_buffer(sock, "Insertion failed.\r\n");
+ }
+ 
+ void editorListDialogBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   if(!*bufferString(buf))
+     text_to_buffer(sock, "Buffer contains not contents.\r\n");
+   else
+     send_to_socket(sock, "%s\r\n", bufferString(buf));
+ }
+ 
+ void editorListBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   if(!*bufferString(buf))
+     text_to_buffer(sock, "Buffer contains not contents.\r\n");
+   else
+     text_to_buffer(sock, bufferString(buf));
+ }
+ 
+ void editorReplace(SOCKET_DATA *sock, char *arg, BUFFER *buf, bool all) {
+   char *a;
+   char *b;
+ 
+   if(count_letters(arg, '\'', strlen(arg)) != 4) {
+     text_to_buffer(sock, "arguments must take the form: 'to replace' 'replacement'\r\n");
+     return;
+   }
+ 
+   // pull the first argument
+   a = strtok(arg, "\'");
+   if(a == NULL) {
+     text_to_buffer(sock, "format is: /r[a] 'to replace' 'replacement'\r\n");
+     return;
+   }
+ 
+   // kill the leading the leading ' of b
+   strtok(NULL, "\'");
+ 
+   b = strtok(NULL, "\'");
+   if(b == NULL)
+     b = "\0"; // "\0" will get deleted at the end of this block
+ 
+   int replaced = bufferReplace(buf, a, b, all);
+   send_to_socket(sock, "%d occurence%s of '%s' replaced with '%s'.\r\n",
+ 		 replaced, (replaced == 1 ? "" : "s"), a, b);
+ }
+ 
+ void editorReplaceString(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   editorReplace(sock, arg, buf, FALSE);
+ }
+ 
+ void editorReplaceAllString(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   editorReplace(sock, arg, buf, TRUE);
+ }
+ 
+ void editorClear(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   bufferClear(buf);
+ }
+ 
+ void editorFormatBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   bufferFormat(buf, 80, 3);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // implementation of editor.h
+ //*****************************************************************************
+ void init_editor() {
+   // install the editor components
+   auxiliariesInstall("editor_aux_data", 
+ 		     newAuxiliaryFuncs(AUXILIARY_TYPE_SOCKET,
+ 				       newEditorAuxData, deleteEditorAuxData,
+ 				       NULL, NULL, NULL, NULL));
+   text_editor   = newEditor();
+   dialog_editor = newEditor();
+   editorSetAppend(dialog_editor, editorDialogAppend);
+   editorRemoveCommand(dialog_editor, "f");
+   editorAddCommand(dialog_editor, "l", 
+ 		   "        List the current buffer contents",
+ 		   editorListDialogBuffer);
+ }
+ 
+ EDITOR *newEditor() {
+   EDITOR *editor = malloc(sizeof(EDITOR));
+   // set up the default commands
+   editor->cmds = newHashtable(EDITOR_CMD_TABLE_SIZE);
+   hashPut(editor->cmds, "q", 
+ 	  newEditorCommand("        Quit editor and save changes",
+ 			   editorQuit, TRUE));
+   hashPut(editor->cmds, "a", 
+ 	  newEditorCommand("        Quit editor and don't save",
+ 			   editorAbort, TRUE));
+   hashPut(editor->cmds, "h", 
+ 	  newEditorCommand("        Display editor commands",
+ 			   editorDisplayHelp, TRUE));
+   hashPut(editor->cmds, "c", 
+ 	  newEditorCommand("        Clear the contents of the buffer",
+ 			   editorClear, TRUE));
+   hashPut(editor->cmds, "l",
+ 	  newEditorCommand("        List the current buffer contents",
+ 			   editorListBuffer, FALSE));
+   hashPut(editor->cmds, "d", 
+ 	  newEditorCommand("#       Delete line with the specified number", 
+ 			   editorDeleteLine, FALSE));
+   hashPut(editor->cmds, "e", 
+ 	  newEditorCommand("# <txt> Sets the text at the specified line to the new text",
+ 			   editorEditLine, FALSE));
+   hashPut(editor->cmds, "i", 
+ 	  newEditorCommand("# <txt> Insert new text at the specified line number",
+ 			   editorInsertLine, FALSE));
+   hashPut(editor->cmds, "f",
+ 	  newEditorCommand("        Formats your text into a paragraph",
+ 			   editorFormatBuffer, FALSE));
+   hashPut(editor->cmds, "r",
+ 	  newEditorCommand("'a' 'b' replace first occurence of 'a' with 'b'",
+ 			   editorReplaceString, FALSE));
+   hashPut(editor->cmds, "ra",
+ 	  newEditorCommand("'a' 'b' repalce all occurences of 'a' with 'b'",
+ 			   editorReplaceAllString, FALSE));
+ 
+   // set up the default prompt, header, and appending function
+   editor->prompt = editorDefaultPrompt;
+   editor->append = editorDefaultAppend;
+   editor->init   = NULL;
+   return editor;
+ }
+ 
+ void editorSetPrompt(EDITOR *editor, void prompt(SOCKET_DATA *sock)) {
+   editor->prompt = prompt;
+ }
+ 
+ void editorSetInit(EDITOR *editor, void init(SOCKET_DATA *sock)) {
+   editor->init = init;
+ }
+ 
+ void editorSetAppend(EDITOR *editor,
+ 		     void append(SOCKET_DATA *sock, char *arg, BUFFER *buf)) {
+   editor->append = append;
+ }
+ 
+ void editorAddCommand(EDITOR *editor, const char *cmd, const char *desc, 
+ 		      void func(SOCKET_DATA *sock, char *arg, BUFFER *buf)) {
+   CMD_DATA *old_cmd = hashGet(editor->cmds, cmd);
+   // make sure we're not trying to replace a reserved command
+   if(!old_cmd || !old_cmd->reserved) {
+     hashPut(editor->cmds, cmd, newEditorCommand(desc, func, FALSE));
+     if(old_cmd) deleteEditorCommand(old_cmd);
+   }
+ }
+ 
+ void editorRemoveCommand(EDITOR *editor, const char *cmd) {
+   CMD_DATA *old_cmd = hashGet(editor->cmds, cmd);
+   // make sure the command isn't reserved
+   if(old_cmd && !old_cmd->reserved) {
+     hashRemove(editor->cmds, cmd);
+     deleteEditorCommand(old_cmd);
+   }
+ }
+ 
+ void socketStartEditor(SOCKET_DATA *sock, EDITOR *editor, BUFFER *buf) {
+   EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data"); 
+   data->working_buf = bufferCopy(buf);
+   data->buf         = buf;
+   data->editor      = editor;
+   if(editor->init) editor->init(sock);
+ 
+   editorDefaultHeader(sock);
+   
+   // if we have a "list" command, execute it. Otherwise, cat the buf
+   CMD_DATA *list = NULL;
+   if((list = hashGet(editor->cmds, "l")) != NULL)
+     list->func(sock, "", buf);
+   else
+     text_to_buffer(sock, bufferString(buf));
+ 
+   socketPushInputHandler(sock, editorInputHandler, editor->prompt);
+ }
+ 
+ EDITOR *socketGetEditor(SOCKET_DATA *sock) {
+   EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data");
+   return data->editor;
+ }
